/*   B_WIN.LIB
     B_WIN.H
     This is a small C++ windowing library that was developed with TC++
     This library is now PUBLIC DOMAIN, and may be freely copied, or
     modified to your hearts content.  It would be nice though to send me
     a copy of your modifications.
     Robert M. Place II
     Quarters 384 D.
     Quantico, Va. 22134
*/

#ifndef B_WINDOWS    1
     #define B_WINDOWS   1
     /***************************************************************
     INCLUDE SECTION
     ****************************************************************/

     #include <stdio.h>
     #include <stdlib.h>
     #include <dos.h>

     /****************************************************************
     DEFINES SECTION
     *****************************************************************/

     // SYSTEM DEFINES
     #define CURSIZE    1         /* used with cursor functions           */
     #define VIDEO      0x10      /* video inturupt                       */
     #define STOPBIT    0x20      /* used with cursor functions           */
     #define MOUSE      0x33      /* mouse inturupt                       */


     // BOARDER COLORS  These can have the bright attribute added.
     #define   BLACK          0
     #define   BLUE           1
     #define   GREEN          2
     #define   CYAN           3
     #define   RED            4
     #define   MAGENTA        5
     #define   BROWN          6
     #define   LT_GRAY        7

     // TEXT FORGROUND COLORS
     #define   DK_GRAY        8
     #define   LT_BLUE        9
     #define   LT_GREEN       10
     #define   LT_CYAN        11
     #define   LT_RED         12
     #define   LT_MAGENTA     13
     #define   YELLOW         14
     #define   WHITE          15

     // COLOR ATTRIBUTES
     #define   YES_BLINK          1
     #define   NO_BLINK       0
     #define   BRIGHT         1
     #define   NORMAL         0

     // BOARDER ATTRIBUTES
     #define   SHADOW         1
     #define   NO_SHADOW      0

     //WINDOW CONSTANTS
     #define   MAX_WINDOWS    8 // max number of open windows.

     /****************************************************************
     GLOBAL VARIABLES
     *****************************************************************/

     // MAIN WINDOW STRUCTURE
     struct    win_data_ovl{
          int  top;
          int  left;
          int  bottom;
          int  right;
          int  border_back_color;
          int  border_fore_color;
          int  bright_attrib;
          int  blink_attrib;
          int  text_back_color;
          int  text_color;
          int  win_shadow;
          int  win_border_type;
          int  *under_the_window;
          char *win_title;
          int  *win_contents;
          int  cursor_x;
          int  cursor_y;          /* Stores the cursor location in a window */
     };

     struct get_list_ovl
     {
          int x;
          int y;
          char *string;
          int size;
          char filler;
     };
     extern struct get_list_ovl get_list[20];

     extern int  MONITOR_TYPE;
     extern int  STRING_ABORT;  // used to abort the get_str() function.
     extern int  CUR_WIN;
     extern int  get_counter;
     extern int  new_counter;
     extern int  max_get_counter;
     extern struct win_data_ovl win_data[MAX_WINDOWS];

// FUNCTION PROTOTYPES //

extern  int GetAt(int x, int y, char *string, int size, char filler);
extern int ReadGets(void);
extern int off(void);
extern int on(void);
extern int FillBox(unsigned char,int ,int ,int, int,unsigned int,unsigned int ,
            unsigned int,unsigned int );
extern int FillItUp(unsigned, int, int, int, int,int);
extern int GetVideoMode(void);
extern int MakeWindow(int, int, int, int, int,int, int , int , int , int , char *,
               int, int);
extern int BWindow(void);
extern int CloseWindow(void);
extern int ColorWindowBorder(int,int,int,int);
extern int ColorWindowText(int, int);
extern int ChangeWindowBorder(int );
extern int WindowShadowOn(void);
extern int WindowShadowOff(void);
extern int ChangeWindowTitle(char *);
extern int get_contents(void);
extern int replace_contents(void);
extern int ClearWindow(void);
extern int MoveWindow(int, int);
extern int GetStr(char *, int, char);
extern int cursor_right(void);
extern int WText(char *, int, int);
extern int CGetStr(char *, int, char,int ,int);
extern int GetGetStr(char *,int ,char );

#endif
